class CreateOlympicTables < ActiveRecord::Migration

  def change
    create_table :teams do |t|
      # edit this.
      <%- if Olympic::Settings.rating_system -%>
      <%- Olympic::Settings.rating_system.required_fields.each do |key, value| -%>
      t.<%= value.first %> <%= key.inspect %>, <%= value.last.inspect[1..-2] %>
      <%- end -%>
      <%- end -%>
      raise NotImplementedError, "Update teams table in #{__FILE__}"
    end

    create_table :tournaments do |t|
      t.string :bracket
      t.integer :root_id
    end

    create_table :teams_tournaments, id: false do |t|
      t.integer :team_id
      t.integer :tournament_id
    end

    create_table :matches_teams, id: false do |t|
      t.integer :match_id
      t.integer :team_id
    end

    create_table :sources do |t|
      t.integer :match_id
      t.integer :source_id
      t.string :source_type
    end

    create_table :matches do |t|
      t.integer :tournament_id
      t.integer :winner_id
      t.integer :depth
      t.integer :offset
      t.integer :value
      t.text :data
    end
  end

end
