require 'olympic/bracket/base'
require 'olympic/bracket/single_elimination'
require 'olympic/bracket/double_elimination'
require 'olympic/bracket/round_robin'

module Olympic
  module Bracket

    BRACKETS = {
      single_elimination: SingleElimination,
      double_elimination: DoubleElimination,
      round_robin: RoundRobin
    }

    def self.for(name, tournament, teams)
      BRACKETS.fetch(name).new(tournament, teams)
    end

  end
end
