require 'memoist'

module Olympic
  module Bracket
    class SingleElimination

      # General information about the tournament.
      #
      # @see Base
      module Information
        extend Memoist

        # (see Base#matches)
        def matches
          @teams.size - 1
        end
        memoize :matches

        # (see Base#rounds)
        def rounds
          Math.log2(@teams.size).ceil
        end
        memoize :rounds

        # (see Base#rounded_teams)
        def rounded_teams
          2 ** rounds
        end
        memoize :rounded_teams

        # (see Base#byes)
        def byes
          rounded_teams - @teams.size
        end
        memoize :byes

        # (see Base#first_round_matches)
        def first_round_matches
          @teams.size - 2 ** Math.log2(@teams.size).floor
        end
        memoize :first_round_matches
      end
    end
  end
end
