module Olympic
  module Team

    extend ActiveSupport::Concern

    included do
      has_and_belongs_to_many :tournaments,
        class_name: Olympic::Settings[:tournament_class],
        join_table: Olympic::Settings[:team_tournament_join],
        foreign_key: Olympic::Settings[:team_join_key],
        association_foreign_key: Olympic::Settings[:tournament_join_key]
      has_many :sources,
        class_name:   Olympic::Settings[:source_class],
        foreign_key:  Olympic::Settings[:source_source_key],
        foreign_type: Olympic::Settings[:source_source_type],
        primary_key:  Olympic::Settings[:team_primary_key],
        as: :sources
      has_many :matches,
        class_name:   Olympic::Settings[:match_class],
        through:      :sources
    end
  end
end
