module Olympic
  module Tournament

    extend ActiveSupport::Concern

    included do
      has_many :matches,
        class_name: Olympic::Settings[:match_class],
        foreign_key: Olympic::Settings[:match_tournament_key],
        primary_key: Olympic::Settings[:tournament_primary_key]
      belongs_to :root,
        class_name: Olympic::Settings[:match_class],
        foreign_key: Olympic::Settings[:tournament_root_key],
        primary_key: Olympic::Settings[:match_primary_key]
      has_and_belongs_to_many :teams,
        class_name: Olympic::Settings[:team_class],
        join_table: Olympic::Settings[:team_tournament_join],
        foreign_key: Olympic::Settings[:tournament_join_key],
        association_foreign_key: Olympic::Settings[:team_join_key]
    end

    module ClassMethods
      def create_tournament(teams:, bracket:)
        tournament = new
        Olympic::Bracket.for(bracket, tournament, teams).call
        tournament
      end
    end

  end
end
